using FitConnect;
using Microsoft.Extensions.Logging;
using NUnit.Framework;

namespace SenderTest;

public class JweTest {
    private ILogger<JweTest> _logger;
    private Sender _sender;


    [SetUp]
    public void SetUp() {
        _logger = LoggerFactory.Create(cfg => cfg.AddConsole())
            .CreateLogger<JweTest>();

        _sender = new Sender(
            FitConnectEndpoints.Create(FitConnectEndpoints.EndpointType.Development), null,
            _logger);
    }

    [Test]
    public void TestJwe() {
        var jwe = _sender.Encryption.GetTestToken();
        Assert.IsNotNull(jwe);

        _logger.LogInformation(jwe);
    }
}
