using Microsoft.Extensions.Logging;

namespace FitConnect.Services;

public class FitConnectApiService {
    protected readonly CasesService CasesService;
    protected readonly DestinationService DestinationService;
    protected readonly OAuthService OAuthService;
    public readonly RouteService RouteService;
    protected readonly SubmissionService SubmissionService;

    public FitConnectApiService(FitConnectEndpoints endpoints, ILogger? logger = null) {
        CasesService = new CasesService(endpoints.SubmissionUrl);
        DestinationService = new DestinationService(endpoints.SubmissionUrl);
        SubmissionService = new SubmissionService(endpoints.SubmissionUrl);
        OAuthService = new OAuthService(endpoints.TokenUrl);
        RouteService = new RouteService(endpoints.RoutingUrl);
    }
}
