# Fit-Connect .NET SDK

**Fit-Connect .NET SDK** is a .NET library for the Fit-Connect API.

## **!! IN DEVELOPMENT NOT FOR PRODUCTION USE !!**

## Structure

```mermaid
 classDiagram
  class FitConnectSDK{
   FitConnectApiService
  }
  
  class FitConnectApiService{
    CasesService
    DestinationService
    InfoService
    OAuthService  
    RouteService  
  }
  
  FitConnectSDK ..> Sender : public
  FitConnectSDK ..> Subscriber : public
  Sender --|> FunctionalBaseClass
  Subscriber --|> FunctionalBaseClass
  FunctionalBaseClass ..> FitConnectApiService : protected

  FitConnectApiService ..> RouteService : public
  FitConnectApiService ..> CasesService : public
  FitConnectApiService ..> DestinationService : public
  FitConnectApiService ..> InfoService : public
  FitConnectApiService ..> OAuthService : public
  
  RouteService --|> RestCallService : Inheritance
  CasesService --|> RestCallService : Inheritance
  DestinationService --|> RestCallService : Inheritance
  InfoService --|> RestCallService : Inheritance
  OAuthService --|> RestCallService : Inheritance
  
```

With that structure the user of the SDK is intended to see the following:

```mermaid
  classDiagram
  
    class FitConnectSDK {
        +SendSumission
        +GetSubmissions
    }
    
    class Sender {
    << Draft >>
        + Einreichung anlegen und ankündigen
        + Anlagen verschlüsseln
        + Anlagen hochladen
        + Metadaten befüllen und verschlüsseln
        + Fachdaten verschlüsseln
        + Fachdaten & Metadaten hochladen und Einreichung absenden
    }
    
    class Subscriber { 
    << Draft >>
     < TO BE DEFINED >
    }
    
      FitConnectSDK --> Sender
      FitConnectSDK --> Subscriber
```

### Annotation

The structure ensures a abstraction of the API calls for the user and a 'simple' way to change the
API calls if a new version of the API is released. Currently the API call is not versioned and hard
coded.

#### Abstractions for API calls

- The use of a dependency injection can be added to
  inject the API calls into the SDK. But is not yet implemented.
- Another approach would be using a generic class for the API calls.

## Ignored Files

The files listed below are ignored and necessary just for development. In production the information
is provided by the user of the SDK.

You need a secret file for e2e test like:

```json
{
  "sender": {
    "id": "00000000-0000-0000-0000-000000000000",
    "secret": "0000000000000000000000000000000000000000000",
    "scope": "send:region:DE"
  }
}
```

[glossary](https://docs.fitko.de/fit-connect/docs/glossary/)

### Tickets

- [Method signatures](https://git.fitko.de/fit-connect/planning/-/issues/438)
- [Java SDK](https://git.fitko.de/fit-connect/planning/-/issues/413)